<?php
/*
 * $Id: Dom.php,v 1.1.1.1 2009/02/26 04:51:00 oops Exp $
 */

Class sURI_Dom {
	private $rtags = array ('input', 'select', 'textarea');
	private $dom;
	public  $validhtml;
	public  $return_dom_compile = false;

	function dom_compile (&$buf, $validhtml = false, $print = false) {
		$this->decode_entities ($buf);

		$this->dom = new DOMDocument ();
		$this->dom->encoding = $this->charset;
		$this->dom->formatOutput = true;

		#$this->summary ();
		$this->validhtml = $validhtml;
		$this->load ($buf);

		$this->form_compile ();
		if ( $this->return_dom_compile === false )
			echo $this->save ();
		else
			return $this->save ();
	}

	function summary () {
		printf ("%-30s : %s\n", 'actualEncoding', $this->dom->actualEncoding);
		printf ("%-30s : %s\n", 'documentURI', $this->dom->documentURI);
		printf ("%-30s : %s\n", 'encoding', $this->dom->encoding);
		printf ("%-30s : %s\n", 'formatOutput', $this->dom->formatOutput);
		printf ("%-30s : %s\n", 'preserveWhiteSpace', $this->dom->preserveWhiteSpace);
		printf ("%-30s : %s\n", 'recover', $this->dom->recover);
		printf ("%-30s : %s\n", 'resolveExternals', $this->dom->resolveExternals);
		printf ("%-30s : %s\n", 'standalone', $this->dom->standalone);
		printf ("%-30s : %s\n", 'substituteEntities', $this->dom->substituteEntities);
		printf ("%-30s : %s\n", 'validateOnParse', $this->dom->validateOnParse);
		printf ("%-30s : %s\n", 'version', $this->dom->version);
		printf ("%-30s : %s\n", 'xmlEncoding', $this->dom->xmlEncoding);
		printf ("%-30s : %s\n", 'xmlVersion', $this->dom->xmlVersion);
	}

	function load ($buf, &$stream = false) {
		$this->set_object ($obj, $stream);
		$this->load_check ($buf);
		$obj->loadHTML ($buf);
	}

	function load_check (&$buf) {
		if ( $this->validhtml )
			return;

		$buf = preg_replace ('/[\r\n]/', '%new-line%', $buf);
		$buf = <<<EOF
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="content-type" content="text/html; charset={$this->charset}" />
</head>
<body>
<hr id="sDom start" />
$buf
<hr id="sDom end" />
</body>
</html>
EOF;
	}

	function save ($stream = false) {
		$this->set_object ($obj, $stream);

		$saves = ($this->htmlver >= XHTML10) ? 'saveXML' : 'saveHTML';

		$obj->xinclude();
		$r = $obj->$saves ();
		if ( ! $this->validhtml ) {
			$r = preg_replace ('!.*<hr id="sDom start"[ /]*>!s', '', $r);
			$r = preg_replace ('!<hr id="sDom end".*!s', '', $r);
			$r = preg_replace ('/%new-line%/', "\n", $r);
		}

		return $r;
	}

	function form_compile (&$stream = false) {
		$this->set_object ($obj, $stream);
		$forms = $this->entity ('form', $obj);

		/*
		 * several forms
		 */
		foreach ( $forms as $form ) {
			$this->cmethod = strtolower ($form->getAttribute ('method'));
			$this->cmethodv = ($this->cmethod == 'get') ? 'G' : 'P';

			/*
			 * input / option / textarea
			 */
			foreach ( $this->rtags as $rtag ) {
				$tags = $this->entity ($rtag);

				foreach ( $tags as $tag ) {
					$name = $tag->getAttribute ('name');

					if ( ! trim ($name) )
						continue;

					$valid = $tag->getAttribute ('valid');

					if ( ! trim ($valid) ) {
						if ( $rtag == 'textarea' )
							$valid = 'FULL';
						else
							continue;
					}

					$this->unbind ($valid);
					$this->bind ($valid);
					$this->name_enc ($name);

					$tag->setAttribute ('name', $name);
					$tag->removeAttribute ('valid');
				}
			}
		}
	}

	function entity ($tag, &$stream = false) {
		$this->set_object ($obj, $stream);
		return $obj->getElementsByTagName ($tag);
	}

	function charsetFix ($attr = 'textContent', &$stream = false) {
		$this->set_object ($obj, $stream);
		return iconv ('utf8', 'iso-8859-1', $obj->$attr);
	}

	function charsetFix_str ($buf) {
		return iconv ('utf8', 'iso-8859-1', $buf);
	}

	function decode_entities (&$buf) {
		$r = array ('/&nbsp;/');
		$d = array (' ');

		$buf = preg_replace ($r, $d, $buf);
	}

	function set_object (&$obj, &$stream = false) {
		$obj = ($stream === false) ? $this->dom : $stream;
	}
}

?>
