<?php
/*
 * $Id: Template.php,v 1.3 2009/03/10 15:13:02 oops Exp $
 */

define ('INTEGERS',  0x0000000f);
define ('ALPHABATS', 0x000000f0);
define ('ASCIIS',    0x00000f00);
define ('STRINGS',   0x0000f000);
define ('FULL',      0x000f0000);

define ('POST',      0x000f);
define ('GET',       0x00ff);

global $get, $post;

Class sURI_Template extends sURI_Dom {
	private $stdAttr = array (
		'id', 'class', 'title', 'style', 'dir', 'lang',
		'xml:lang', 'accesskey', 'tabindex'
	);
	private $eventAttr = array (
		'onload', 'onunload', 'onchange', 'onsubmit', 'onreset',
		'onselect', 'onblur', 'onfocus', 'onkeydown', 'onkeypress',
		'onkeyup', 'onclick', 'ondbclick', 'onmousedown', 'onmouseover',
		'onmouseout', 'onmouseup'
	);
	private $formAttr = array (
		'accept', 'accept-charset', 'name', 'type'
	);

	private $inputAttr = array (
		'value', 'accept', 'align', 'alt', 'disabled', 'maxlength',
		'readonly', 'size', 'src'
	);

	private $selectAttr = array (
		'disabled', 'multiple', 'size'
	);

	private $textareaAttr = array (
		'readonly', 'disabled', 'wordwrap'
	);

	public $addnewline = false;
	public $cmethod  = 'get';
	public $cmethodv = 'G';
	private $bindv = null;
	private $bindh = null;

	// {{{ attset
	/**
	 * @access private
	 * @param string $value (optional) defaults to 'form'
	 */
	private function attrset ($v = null) {
		if ( $v === null )
			return array_merge ($this->stdAttr, $this->eventAttr);

		$name = $v . 'Attr';
		return array_merge ($this->{$name}, $this->stdAttr, $this->eventAttr);
	}
	// }}}

	// {{{ action_attr
	/**
	 *
	 * @access private
	 * @param string $type
	 * @param array $attr
	 */
	private function action_attr ($type, $attr = null) {
		$this->array_is (&$attr);
		$filter = $this->attrset ($type);

		foreach ( $attr as $key => $value ) {
			$key = strtolower ($key);
			if ( array_search ($key, $filter) === FALSE ) {
				$this->set_error ('\'' . $key . '\' is invalid attributes of reset');
				return false;
			}
			$buf .= $key . '="' . $value . '" ';
		}

		return $buf;
	}


	// {{{ form
	/**
	 * @access public
	 * @param string $method lowcase string whether 'post' or 'get' or 'end'
	 * @param string $action (optional) defaults to $_SERVER['PHP_SELF']
	 * @param bool $bin (optional) print file upload mime type. default to false
	 * @param array $attr (optional) other for attributes. defaults to null
	 * @return bool
	 */
	function form ($method, $action = null, $bin = false, $attr = null) {
		$method = strtolower ($method);
		if ( array_search ($method, array ('post', 'get', 'end')) === FALSE ) {
			$this->set_error ('\'' . $method . '\' is invalid value of form method');
			return false;
		}

		if ( $method == 'end' ) {
			echo '</form>';
			$this->newline ();
			$this->cmethod  = 'get';
			$this->cmethodv = 'G';
			return true;
		}

		$action = trim ($action) ? trim ($action) : $_SERVER['PHP_SELF'];

		$this->cmethod  = strtolower ($method);
		$this->cmethodv = ($method == 'get') ? 'G' : 'P';

		$buf = '<form ';
		$buf .= 'method="' . $method . '" ';

		if ( $bin != false )
			$buf .= 'enctype="multipart/form-data" ';

		$attr_buf = $this->action_attr ('form', $attr);
		if ( $attr_buf === false )
			return false;
		$buf .= $attr_buf;

		$buf .= 'action="' . $this->addrenc ($action) . '">';
		$this->output ($buf);

		return true;
	}
	// }}}

	function input ($type, $name, $attr = null) {
		$type = strtolower ($type);

		if ( array_search ($type, array ('file', 'text', 'image', 'password')) === FALSE ) {
			$this->set_error ('\'' . $type . '\' is invalid value of input method');
			return false;
		}

		if ( ! $this->name_is ($name) )
			return false;

		if ( ! $this->bindv )
			$this->bind (INTEGERS);

		$this->name_enc ($name);

		$buf  = '<input ';
		$buf .= 'type="' . $type . '" ';
		$buf .= 'name="' . $name . '" ';

		$filter = $this->attrset ('input');
		$this->array_is (&$attr);
		foreach ($attr as $key => $value) {
			$key = strtolower ($key);
			if ( array_search ($key, $filter) === FALSE ) {
				$this->set_error ('\'' . $key . '\' is invalid attributes of form');
				return false;
			}

			if ( $type != 'image' &&  array_search ($key, array ('src', 'align', 'alt')) !== FALSE ) {
				$this->set_error ('\'' . $key . '\' is only valid attribute on image type');
				return false;
			}

			if ( $type == 'image' && array_search ($key, array ('maxlength', 'readonly')) === FALSE ) {
				$this->set_error ('\'' . $key . '\' is only valid attribute on text or password type');
				return false;
			}

			$value = ($key == 'src' ) ? $this->addrenc ($value) : $value;
			$value = ($key == 'value' ) ? $this->urlenc ($value) : $value;
			$buf .= $key . '="' . $value . '" ';
		}
		$this->tagclose (&$buf);
		$this->output ($buf);

		return true;
	}

	function file ($name, $attr = null) {
		if ( ! $this->bindv )
			$this->bind (STRINGS);
		return $this->input ('file', $name, $attr);
	}

	function image ($name, $attr = null) {
		if ( ! $this->bindv )
			$this->bind (STRINGS);
		return $this->input ('image', $name, $attr);
	}

	function password ($name, $attr = null) {
		if ( ! $this->bindv )
			$this->bind (FULL);
		return $this->input ('password', $name, $attr);
	}


	function textarea ($name, $value = null, $row = 10, $col = 70, $attr = null) {
		if ( ! $this->bindv )
			$this->bind (FULL);

		if ( ! $this->name_is ($name) )
			return false;

		$this->name_enc ($name);

		$buf  = '<textarea ';
		$buf .= 'name="' . $name . '" ';
		$buf .= 'rows="' . $row . '" ';
		$buf .= 'cols="' . $col . '" ';

		$attr_buf = $this->action_attr (textarea, $attr);
		if ( $attr_buf === false )
			return false;
		$buf .= $attr_buf;

		$oldnewline = $this->addnewline;
		$this->addnewline = false;
		$this->tagclose (&$buf, false);
		$this->output ($buf);

		if ( $value )
			echo $value;

		$this->addnewline = $oldnewline;
		echo "</textarea>";
		$this->newline();

		return true;
	}

	function radio ($name, $value, $msg_prefix = false) {
		if ( ! $this->bindv )
			$this->bind (INTEGERS);

		$this->array_is (&$value, true);
		if ( preg_match ('/^cbox:(.*)/', $name, $matches) ) {
			$name = $matches[1];
			$types = 'checkbox';
		} else {
			$types = 'radio';
		}

		if ( ! $this->name_is ($name) )
			return false;

		$this->name_enc (&$name);

		$i = 0;
		foreach ( $value as $v ) {
			if ( is_array ($v) ) {
				$comment = $v[0];
				$val = $v[1] ? $v[1] : $v[0];
				$checked = $v[2] ? 'checked="checked" ' : '';
			} else {
				$val = $v;
				$comment = $v;
				$checked = ($i == 0) ? 'checked="checked" ' : '';
			}

			if ( $msg_prefix )
				echo $comment . ' ';
			$buf = '<input type="' . $types . '" ';
			$buf .= 'name="' . $name . '" ';
			$buf .= 'value="' . $this->urlenc ($val) . '" ';
			$buf .= $checked ? $checked : '';
			$this->tagclose (&$buf);

			if ( ! $locate ) {
				$oldnewline = $this->addnewline;
				$this->addnewline = false;
			}
			$this->output ($buf);
			if ( ! $msg_prefix ) {
				echo $comment;
				$this->addnewline = $oldnewline;
				$this->newline ();
			}

			$i++;
		}
	}

	function select ($name, $value, $attr = null) {
		if ( ! $this->bindv )
			$this->bind (INTEGERS);

		if ( ! $this->name_is ($name) )
			return false;

		$this->name_enc ($name);

		$buf  = '<select ';
		$buf .= 'name="' . $name . '" ';

		$attr_buf = $this->action_attr ('select', $attr);
		if ( $attr_buf === false )
			return false;
		$buf .= $attr_buf;

		$this->tagclose (&$buf, false);
		$this->output ($buf);

		$this->array_is (&$value);
		$i = 0;
		$buf = '';
		foreach ( $value as $v ) {
			if ( is_array ($v) ) {
				$comment = $v[0];
				$val = $v[1] ? $v[1] : $v[0];
				$checked = $v[2] ? ' selected="selected"' : '';
			} else {
				$val = $v;
				$comment = $v;
				$checked = ($i == 0) ? ' selected="selected"' : '';
			}

			$buf .= "\t<option value=\"{$val}\"{$checked}>{$comment}</option>\n";

			$i++;
		}
		echo $buf;

		echo "</select>";
		$this->newline();

		return true;
	}

	function checkbox ($name, $value, $msg_prefix = false) {
		return $this->radio ('cbox:' . $name, $value, $msg_prefix);
	}

	function button ($value, $attr = null) {
		if ( ! trim ($value) )
			$value = 'BUTTON';

		$buf = '<input type="button" ';
		$buf .= 'type="' . $value . '" ';

		$attr_buf = $this->action_attr (null, $attr);
		if ( $attr_buf === false )
			return false;
		$buf .= $attr_buf;

		$this->tagclose (&$buf);
		$this->output ($buf);
	}

	function hidden ($name, $value) {
		if ( ! $this->bindv )
			$this->bind (STRINGS);

		if ( ! $this->name_is ($name) )
			return false;

		$this->name_enc (&$name);

		$buf = '<input type="hidden" ';
		$buf .= 'name="' . $name . '" ';
		$buf .= $value ? 'value="' . $this->urlenc ($value) . '" ' : '';
		$this->tagclose (&$buf);
		$this->output ($buf);
	}

	function reset ($value = '', $attr = null) {
		$buf = '<input type="reset" ';
		$buf .= $value ? 'value="' . $value . '" ' : '';

		$attr_buf = $this->action_attr (null, $attr);
		if ( $attr_buf === false )
			return false;
		$buf .= $attr_buf;

		$this->tagclose (&$buf);
		$this->output ($buf);
	}

	function submit ($name = '', $value = '', $attr = null) {
		if ( $name )
			$this->name_enc (&$name);

		$buf = '<input type="submit" ';
		$buf .= $name ? 'name="' . $name . '" ' : '';
		$buf .= $value ? 'value="' . $value . '" ' : '';

		$attr_buf = $this->action_attr (null, $attr);
		if ( $attr_buf === false )
			return false;
		$buf .= $attr_buf;

		$this->tagclose (&$buf);
		$this->output ($buf);
	}

	/**
	 * Variable type binding
	 *
	 * @access public
	 * @param int $v
	 *        INTEGER    0x0000000f only [0-9]
	 *        ALPHABAT   0x000000f0 only [a-zA-Z]
	 *        ASCII      0x00000f00 only ascii area
	 *        STRINGS    0x0000f000 0x00 ~ 0xff except meta character and null (parsed null)
	 *        FULL       0x000f0000
	 */
	function bind ($v, $type = POST) {
		if ( $type === GET ) {
			$this->bindget (&$v);
			return $v;
		}

		switch ($v) {
			case 0x000fffff :
			case 0x000ffff0 :
			case 0x000fff00 :
			case 0x000ff000 :
			case 0x000f0000 :
				// FULL
				$this->bindv = 'F';
				break;
			case 0x0000ffff :
			case 0x0000fff0 :
			case 0x0000ff00 :
			case 0x0000f000 :
				// STRING
				$this->bindv = 'S';
				break;
			case 0x00000fff :
			case 0x00000ff0 :
			case 0x00000f00 :
				// ASCII
				$this->bindv = 'a';
				break;
			case 0x000000ff :
				// INTEGER & ALPHABAT
				$this->bindv = 'R';
				break;
			case 0x000000f0 :
				// ALPHABAT
				$this->bindv = 'A';
				break;
			default :
				// INTEGER
				$this->bindv = 'I';
		}

		$this->bindh = $this->bind_hash ($this->cmethodv . $this->bindv);
	}

	function unbind (&$key) {
		switch ($key) {
			case 'INTEGERS' :
			case 'INTEGER' :
				$key = INTEGERS;
				break;
			case 'ALPHABATS' :
			case 'ALPHABAT' :
				$key = ALPHABATS;
				break;
			case 'ASCIIS' :
			case 'ASCII' :
				$key = ASCIIS;
				break;
			case 'STRINGS' :
			case 'STRING' :
				$key = STRINGS;
				break;
			case 'FULL' :
				$key = FULL;
				break;
			case 'INTEGER|ALPHABAT' :
			case 'INTEGER|ALPHABATS' :
			case 'INTEGERS|ALPHABAT' :
			case 'INTEGERS|ALPHABATS' :
			case 'ALPHABAT|INTEGER' :
			case 'ALPHABAT|INTEGERS' :
			case 'ALPHABATS|INTEGER' :
			case 'ALPHABATS|INTEGERS' :
				$key = 0x000000ff;
				break;
			case 'NONE' :
				$key = 0x00000000;
				break;
			default :
				$key = INTEGERS;
		}
	}

	private function bindget ($v) {
		if ( ! strlen ($v) )
			return;

		if ( ! preg_match ('/[?]/', $v) )
			return;

		$pos = strpos ($v, '?');
		$_uri = (object) array ();
		$_uri->path = substr ($v, 0, $pos);
		$_uri->query = substr ($v, $pos + 1);

		$this->cmethod  = 'get';
		$this->cmethodv = 'G';

		parse_str ($_uri->query, $uri);
		if ( ! is_array ($uri) )
			return;

		foreach ( $uri as $name => $v ) {
			if ( preg_match ('/^([^:]+):(.+)$/', $name, $matches) ) {
				$key = $matches[1];
				$name = $matches[2];
			} else
				$key = $this->legacy ? 'NONE' : 'INTEGERS';

			$this->unbind ($key);

			if ( $key != 0x00 ) {
				$this->bind ($key);
				$this->name_enc ($name);
			}
			$newuri .= $name . '=' . rawurlencode ($v) . '&';
		}

		$pattern_src = array ('/[&]$/', '/[&]/', '/[&]amp;amp;/');
		$pattern_dst = array ('', '&amp;', '&amp;');
		$newuri = preg_replace ($pattern_src, $pattern_dst, $newuri);

		$v = $_uri->path . '?' . $newuri;
	}

	private function name_is ($var) {
		if ( ! trim ($var) ) {
			$this->set_error ('\'name\' attribute is not set');
			return false;
		}

		return true;
	}

	function name_enc (&$name) {
		global $___hashunit;

		$prefix = $this->bind_hash_random ($this->cmethodv . $this->bindv);
		$postfix = $this->bindh;

		$name_key = $this->make_name_key ($name);
		$postfix .= $name_key;

		$name_ary = '';
		if ( preg_match ('/(.*)(\[\])$/', $name, $matches) ) {
			$name = $matches[1];
			$name_ary = $matches[2];
		}
		$name = $prefix . '_' . $name . '_' . $postfix . $name_ary;
	}

	public function make_name_key ($name) {
		global $___hashunit;

		$key = $this->name_enc_key ();
		$len = count ($name);

		$_key = 0;
		for ( $i=0; $i<$len; $i++ )
			$_key += ord ($name[$i]);

		$key = ($_key + $key) % count ($___hashunit[$this->hashtype]['N']);
		return $___hashunit[$this->hashtype]['N'][$key];
	}

	private function name_enc_key () {
		global $___hashunit;
		$_hashes = $___hashunit[$this->hashtype]['N'];

		$key = 0;
		foreach ( $_hashes as $val )
			$key += ord ($val);

		return $key % count ($_hashes);
	}

	private function output ($var) {
		#echo preg_replace ('![ ]+(/>)!', '\\1', $var);
		echo $var;
		$this->newline ();
		$this->bindv = null;
		$this->bindh = null;
	}

	private function tagclose (&$var, $selfclose = true) {
		if ( $selfclose === false )
			$var .= '>';
		else
			$var .= $this->xhtmlclose . '>';
	}

	private function urlenc ($var) {
		if ( $this->urlencode === false )
			return $var;
		return rawurlencode ($var);
	}

	private function addrenc ($var) {
		return htmlspecialchars ($var);
	}

	private function newline () {
		if ( $this->addnewline )
			echo "\n";
	}

	private function self_attribute ($var) {
		$selfs = array ('checked', 'disabled', 'readonly');
		if ( array_search ($var, $selfs) !== FALSE )
			return $var;

		return null;
	}
}
?>
